#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include "vnctermserv.h"

char* ugbuf=0;
int uglen=0;


void unread(char*ub,int ulen)
{
ugbuf=malloc(ulen);
memcpy(ugbuf,ub,ulen);
uglen=ulen;
}

int readug(int fw,char*t,int len)
{
if(uglen){
if(uglen<len)len=uglen;
memcpy(t,ugbuf,len);
uglen-=len;
ugbuf+=len;
return len;
}
return read(fw,t,len);
}

int readint32(int fd)
{unsigned char c[4];int i,j=0;
lp:i=readug(fd,&c[j],4-j);
if(i==-1&&errno==EAGAIN)goto lp;
if(i==-1||i==0)exit(1);
j+=i;
if(j!=4)goto lp;
return (c[0]<<24)|(c[1]<<16)|(c[2]<<8)|(c[3]);
}
void readstring(int fd,char*t,int maxlen)
{int len,len1=readint32(fd);int readc=0;
char buf[2];int i;
if(len1<maxlen-1)len=len1;else len=maxlen-1;
while(readc<len){
i=readug(fd,&t[readc],len-readc);
if(i==-1&&errno==EAGAIN)continue;
if(i==-1||i==0)exit(1);
readc+=i;
}
t[len]=0;
len=len1-len;
while(len>0){readug(fd,&buf,1);len--;}
}


void writeint32(int fd,int i)
{char c[4];
c[0]=(i>>24)&0xff;
c[1]=(i>>16)&0xff;
c[2]=(i>>8)&0xff;
c[3]=i&0xff;
write(fd,&c,4);
}

void writestring(int fd,char*msg)
{
writeint32(fd,strlen(msg));
write(fd,msg,strlen(msg));
}

elist* readEntryList(int fd,int count)
{elist* el;int i;
el=malloc(sizeof(elist)*count);
for(i=0;i<count;i++)
{readstring(fd,el[i][0],sizeof(el[i][0]));
readstring(fd,el[i][1],sizeof(el[i][1]));}
return el;}

void SendEntryList(char*title,int count,elist*e)
{int i;
const char* StartMsg="\nSTART_VNCTERMSERV\n";
write(1,StartMsg,strlen(StartMsg));
writestring(1,title);
writeint32(1,count);
for(i=0;i<count;i++)
{
writestring(1,e[i][0]);writestring(1,e[i][1]);
}
}
