#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <libintl.h>

#include "vnctermserv.h"

char* pwtext=NULL;
int msgresult=0;
int rowselid,ConnFlag=0;
int widget_vis=0;

void msg_callback( GtkWidget *widget,
                     void *entry )
{
msgresult=(int)entry;
gtk_main_quit();
}

void enter_callback( GtkWidget *widget,
                     GtkWidget *entry )
{
pwtext=gtk_entry_get_text(GTK_ENTRY(entry));
gtk_main_quit();
}

int enter_keypress(GtkWidget* entry,GdkEventKey* event, gpointer* data)
{
if(event->type==GDK_KEY_PRESS&&(event->keyval==GDK_Return||event->keyval==GDK_KP_Enter))
{enter_callback(entry,entry);
return FALSE;}
return TRUE;}

void advshow_clicked(gpointer data)
{
  if(!widget_vis)
   gtk_widget_show(GTK_WIDGET(data));
else
   gtk_widget_hide(GTK_WIDGET(data));
  widget_vis=!widget_vis;
}

void cancelbutton_clicked( gpointer data )
{
gtk_main_quit();
}

void connectbutton_clicked( gpointer data )
{
gtk_main_quit();
ConnFlag=1;
}

void killbutton_clicked( gpointer data )
{
gtk_main_quit();
ConnFlag=2;
}

void double_click(GtkObject *object, GdkEventButton *event,
                        gpointer data)
{if (event->type == GDK_2BUTTON_PRESS || event->type == GDK_3BUTTON_PRESS)
                connectbutton_clicked(data);      
}

void selection_made( GtkWidget *clist,gint row,gint column,GdkEventButton *event,gpointer  data )
{
rowselid=row;
}


char* gtkgetpass(const char* prompt)
{

    GtkWidget *window;
    GtkWidget *vbox, *hbox;
    GtkWidget *entry;
    GtkWidget *okbutton;
    GtkWidget *cancelbutton;
    GtkWidget *label;

    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    label=gtk_label_new(prompt);
    okbutton = gtk_button_new_with_label (gettext("Ok"));
    cancelbutton = gtk_button_new_with_label (gettext("Cancel"));
    entry = gtk_entry_new_with_max_length (50);

    vbox = gtk_vbox_new (FALSE, 0);
    hbox = gtk_hbox_new (FALSE, 0);


    gtk_signal_connect(GTK_OBJECT (window), "delete_event",
                       (GtkSignalFunc) gtk_exit, NULL);
    gtk_signal_connect(GTK_OBJECT(entry),"key_press_event",
			GTK_SIGNAL_FUNC(enter_keypress),entry);
    gtk_signal_connect (GTK_OBJECT (okbutton), "clicked",
                               GTK_SIGNAL_FUNC(enter_callback),
                               entry);
    gtk_signal_connect_object (GTK_OBJECT (cancelbutton), "clicked",
                               GTK_SIGNAL_FUNC(gtk_exit),
                               GTK_OBJECT (window));


    gtk_window_set_title(GTK_WINDOW (window), gettext("vnctermserv password"));
    gtk_window_set_default_size(GTK_WINDOW(window), 300, 150);
    gtk_container_set_border_width(GTK_CONTAINER(window), 5);
    gtk_window_set_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);

    gtk_entry_set_text (GTK_ENTRY (entry), "");
    gtk_entry_set_visibility(GTK_ENTRY(entry),FALSE);

    GTK_WIDGET_SET_FLAGS (okbutton, GTK_CAN_DEFAULT);
    GTK_WIDGET_SET_FLAGS (cancelbutton, GTK_CAN_DEFAULT);

    gtk_container_add (GTK_CONTAINER (window), vbox);
    gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 0);
    gtk_box_pack_start (GTK_BOX (vbox), entry, FALSE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 4);
    gtk_box_pack_start (GTK_BOX (hbox), okbutton, TRUE, TRUE, 0);
    gtk_box_pack_start (GTK_BOX (hbox), cancelbutton, TRUE, TRUE, 0);
    

    gtk_widget_show (label);
    gtk_widget_show (entry);
    gtk_widget_show (okbutton);
    gtk_widget_show (cancelbutton);
    gtk_widget_show (hbox);
    gtk_widget_show (vbox);
    gtk_widget_show(window);

    gtk_widget_grab_focus(entry);
    gtk_widget_grab_default(okbutton);

gtk_main();
gtk_widget_hide(window);
gtk_main_iteration_do(FALSE);
return pwtext;
}

int gtkmsg(const char* prompt,int mode)
{

    GtkWidget *window;
    GtkWidget *vbox, *hbox;
    GtkWidget *okbutton;
    GtkWidget *cancelbutton;
    GtkWidget *label;

    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    label=gtk_label_new(prompt);
if(mode==1||mode==2){
    okbutton = gtk_button_new_with_label (gettext("Ok"));
    cancelbutton = gtk_button_new_with_label (gettext("Cancel"));
}else
{
    okbutton = gtk_button_new_with_label (gettext("Yes"));
    cancelbutton = gtk_button_new_with_label (gettext("No"));
}
    vbox = gtk_vbox_new (FALSE, 0);
    hbox = gtk_hbox_new (FALSE, 0);


    gtk_signal_connect(GTK_OBJECT (window), "delete_event",
                      GTK_SIGNAL_FUNC(msg_callback), (void*)0);
    gtk_signal_connect (GTK_OBJECT (okbutton), "clicked",
                               GTK_SIGNAL_FUNC(msg_callback),
                               (void*)1);
    gtk_signal_connect (GTK_OBJECT (cancelbutton), "clicked",
                               GTK_SIGNAL_FUNC(msg_callback),
                               (void*)0);


    gtk_window_set_title(GTK_WINDOW (window), gettext("vnctermserv"));
    gtk_window_set_default_size(GTK_WINDOW(window), 300, 100);
    gtk_container_set_border_width(GTK_CONTAINER(window), 5);
    gtk_window_set_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);


    GTK_WIDGET_SET_FLAGS (okbutton, GTK_CAN_DEFAULT);
    GTK_WIDGET_SET_FLAGS (cancelbutton, GTK_CAN_DEFAULT);

    gtk_container_add (GTK_CONTAINER (window), vbox);
    gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 4);
    gtk_box_pack_start (GTK_BOX (hbox), okbutton, TRUE, TRUE, 0);
if(mode==0||mode==1){
    gtk_box_pack_start (GTK_BOX (hbox), cancelbutton, TRUE, TRUE, 0);
    gtk_widget_show (cancelbutton);
    }

    gtk_widget_show (label);
    gtk_widget_show (okbutton);
    gtk_widget_show (hbox);
    gtk_widget_show (vbox);
    gtk_widget_show(window);

    gtk_widget_grab_default(okbutton);

gtk_main();
gtk_widget_hide(window);
gtk_main_iteration_do(FALSE);
return msgresult;
}

int DoSelect(elist *list,int cnt,char*Title)
{int i;
    GtkWidget *window;char *li[2];
    GtkWidget *vbox, *hbox;
    GtkWidget *scrolled_window, *clist;
    GtkWidget *connectbutton,*cancelbutton,*label,*killbutton;    
    GtkWidget * depth,*res,*session,*adv,*advbox,*advhbox;
    GList* l1,*l2,*l3; char defres[20];


    window=gtk_window_new(GTK_WINDOW_TOPLEVEL);

    
    vbox=gtk_vbox_new(FALSE, 0);
    hbox = gtk_hbox_new(FALSE, 5);
    advhbox = gtk_hbox_new(FALSE, 5);
    advbox=gtk_vbox_new(FALSE,5);
    scrolled_window = gtk_scrolled_window_new (NULL, NULL);

    killbutton = gtk_button_new_with_label(gettext("Kill"));
    connectbutton = gtk_button_new_with_label(gettext("Connect"));
    cancelbutton = gtk_button_new_with_label(gettext("Cancel"));
    label=gtk_label_new(gettext("Select session to resume:"));
    clist = gtk_clist_new( 2);
    depth=gtk_combo_new();
    res=gtk_combo_new();
    session=gtk_combo_new();
    adv=gtk_toggle_button_new_with_label(gettext("New session settings"));



    gtk_signal_connect_object(GTK_OBJECT(cancelbutton), "clicked",
                              GTK_SIGNAL_FUNC(cancelbutton_clicked),
                              (gpointer) 0);

    gtk_signal_connect_object(GTK_OBJECT(connectbutton), "clicked",
                              GTK_SIGNAL_FUNC(connectbutton_clicked),
                              (gpointer) 0);
    gtk_signal_connect_object(GTK_OBJECT(killbutton), "clicked",
                              GTK_SIGNAL_FUNC(killbutton_clicked),
                              (gpointer) 0);
    gtk_signal_connect_object(GTK_OBJECT(adv),"clicked",GTK_SIGNAL_FUNC(advshow_clicked),
			      (gpointer)advbox);
    gtk_signal_connect_object(GTK_OBJECT(clist), "button_press_event",
                              GTK_SIGNAL_FUNC(double_click),
                              (gpointer) 0);
    gtk_signal_connect(GTK_OBJECT(window),
                       "destroy",
                       GTK_SIGNAL_FUNC(cancelbutton_clicked),
                       NULL);
    gtk_signal_connect(GTK_OBJECT(clist), "select_row",
                       GTK_SIGNAL_FUNC(selection_made),
                       NULL);

   gtk_clist_set_shadow_type (GTK_CLIST(clist), GTK_SHADOW_IN);
   gtk_clist_set_selection_mode(GTK_CLIST(clist),GTK_SELECTION_BROWSE);
   gtk_window_set_title(GTK_WINDOW(window), Title);

    for ( i=0 ; i < cnt ; i++ )
     {li[0]=list[i][0];li[1]=list[i][1];
   gtk_clist_append( GTK_CLIST(clist), li);}
    gtk_clist_select_row(GTK_CLIST(clist),0,0);
    gtk_clist_columns_autosize(GTK_CLIST(clist));

    gtk_clist_column_titles_hide((GtkCList *) clist);
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
                                    GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

    l1=l2=l3=NULL;
    l3=g_list_append(l3,"8");
    l3=g_list_append(l3,"16");
    l3=g_list_append(l3,"32");
    sprintf(defres,"%dx%d",DefaultX,DefaultY);
    l2=g_list_append(l2,defres);
    l2=g_list_append(l2,"640x480");
    l2=g_list_append(l2,"800x600");
    l2=g_list_append(l2,"1024x768");
    l2=g_list_append(l2,"1280x1024");
    l2=g_list_append(l2,"1600x1200");
    for(i=0;i<SessionCount;i++)
    l1=g_list_append(l1,Sessions[i]);
    /*    l1=g_list_append(l1,"default");
	  l1=g_list_append(l1,"failsafe");*/



    gtk_combo_set_popdown_strings(GTK_COMBO(session),l1);
    gtk_combo_set_popdown_strings(GTK_COMBO(res),l2);
    gtk_combo_set_popdown_strings(GTK_COMBO(depth),l3);
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(depth)->entry),(DefaultDepth==8?"8":(DefaultDepth==16?"16":"32")));

    gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(res)->entry),FALSE);
    gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(depth)->entry),FALSE);

    gtk_window_set_default_size(GTK_WINDOW(window), 300, 600);
    gtk_container_set_border_width(GTK_CONTAINER(window), 5);
    gtk_window_set_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);
    gtk_container_set_border_width(GTK_CONTAINER(vbox), 5); 

    gtk_container_add(GTK_CONTAINER(window), vbox);
    gtk_box_pack_start(GTK_BOX(advbox),session,FALSE,TRUE,4);
    gtk_box_pack_start(GTK_BOX(advhbox),res,FALSE,TRUE,4);
    gtk_box_pack_start(GTK_BOX(advhbox),depth,FALSE,TRUE,4);
    gtk_box_pack_start(GTK_BOX(advbox),advhbox,FALSE,TRUE,4);
    gtk_box_pack_start(GTK_BOX(vbox),adv,FALSE,TRUE,4);
    gtk_box_pack_start(GTK_BOX(vbox),advbox,FALSE,TRUE,4);
    gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, TRUE, 4);
    gtk_box_pack_start(GTK_BOX(vbox), scrolled_window, TRUE, TRUE, 4);
    gtk_container_add(GTK_CONTAINER(scrolled_window), clist);
    gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 4);
    gtk_box_pack_start(GTK_BOX(hbox), connectbutton, TRUE, TRUE, 4);
    gtk_box_pack_start(GTK_BOX(hbox), cancelbutton, TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(hbox), killbutton, TRUE, TRUE, 0);
    GTK_WIDGET_SET_FLAGS(connectbutton,GTK_CAN_DEFAULT);
    GTK_WIDGET_SET_FLAGS(cancelbutton,GTK_CAN_DEFAULT);
    gtk_widget_grab_default(GTK_WIDGET(connectbutton));

    gtk_widget_show(connectbutton);
    gtk_widget_show(cancelbutton);
    gtk_widget_show(killbutton);
    gtk_widget_show(label);
    gtk_widget_show(vbox);
    gtk_widget_show(hbox);
    gtk_widget_show(adv);
    gtk_widget_show(advhbox);
    gtk_widget_show(session);
    gtk_widget_show(res);
    gtk_widget_show(depth);
    gtk_widget_show (scrolled_window);
    gtk_widget_show(clist);

    gtk_widget_show(window);

    gtk_main();
    gtk_widget_hide_all(window);
gtk_main_iteration_do(FALSE);
{ sessionname=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(depth)->entry));
 sscanf(sessionname,"%d",&DefaultDepth);
 sessionname=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(res)->entry));
 sscanf(sessionname,"%dx%d",&DefaultX,&DefaultY);
 sessionname=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(session)->entry));
}
    return(0);
}
